--- old/usr/src/uts/common/inet/sctp/sctp_output.c	2014-04-12 11:18:56.226900530 +0000
+++ new/usr/src/uts/common/inet/sctp/sctp_output.c	2014-04-12 11:18:56.234329235 +0000
@@ -977,6 +977,11 @@
 	}
 
 	sctp_set_iplen(sctp, head, fp->sf_ixa);
+
+	DTRACE_SCTP5(send, mblk_t *, NULL, ip_xmit_attr_t *, fp->sf_ixa,
+	    void_ip_t *, mp->b_rptr, sctp_t *, sctp, sctp_hdr_t *,
+	    &mp->b_rptr[fp->sf_ixa->ixa_ip_hdr_length]);
+
 	(void) conn_ip_output(head, fp->sf_ixa);
 	BUMP_LOCAL(sctp->sctp_opkts);
 	sctp->sctp_active = fp->sf_lastactive = ddi_get_lbolt64();
@@ -1279,6 +1284,11 @@
 		    ntohs(sdc->sdh_ssn), (void *)fp, sctp->sctp_frwnd,
 		    cansend, sctp->sctp_lastack_rxd));
 		sctp_set_iplen(sctp, head, fp->sf_ixa);
+
+		DTRACE_SCTP5(send, mblk_t *, NULL, ip_xmit_attr_t *, fp->sf_ixa,
+		    void_ip_t *, head->b_rptr, sctp_t *, sctp, sctp_hdr_t *,
+		    &head->b_rptr[fp->sf_ixa->ixa_ip_hdr_length]);
+
 		(void) conn_ip_output(head, fp->sf_ixa);
 		BUMP_LOCAL(sctp->sctp_opkts);
 		/* arm rto timer (if not set) */
@@ -1803,6 +1813,12 @@
 		if (pkt != NULL) {
 			ASSERT(pkt_len <= fp->sf_pmss);
 			sctp_set_iplen(sctp, pkt, fp->sf_ixa);
+
+			DTRACE_SCTP5(send, mblk_t *, NULL,
+			    ip_xmit_attr_t *, fp->sf_ixa,
+			    void_ip_t *, mp->b_rptr, sctp_t *, sctp, sctp_hdr_t *,
+			    &mp->b_rptr[fp->sf_ixa->ixa_ip_hdr_length]);
+
 			(void) conn_ip_output(pkt, fp->sf_ixa);
 			BUMP_LOCAL(sctp->sctp_opkts);
 		} else {
@@ -2023,6 +2039,11 @@
 	sctp->sctp_rxt_nxttsn = first_ua_tsn;
 	sctp->sctp_rxt_maxtsn = sctp->sctp_ltsn - 1;
 	sctp_set_iplen(sctp, head, fp->sf_ixa);
+
+	DTRACE_SCTP5(send, mblk_t *, NULL, ip_xmit_attr_t *, fp->sf_ixa,
+	    void_ip_t *, mp->b_rptr, sctp_t *, sctp, sctp_hdr_t *,
+	    &mp->b_rptr[fp->sf_ixa->ixa_ip_hdr_length]);
+
 	(void) conn_ip_output(head, fp->sf_ixa);
 	BUMP_LOCAL(sctp->sctp_opkts);
 
@@ -2307,6 +2328,11 @@
 		iph->ipha_fragment_offset_and_flags = 0;
 	}
 	sctp_set_iplen(sctp, pkt, fp->sf_ixa);
+
+	DTRACE_SCTP5(send, mblk_t *, NULL, ip_xmit_attr_t *, fp->sf_ixa,
+	    void_ip_t *, mp->b_rptr, sctp_t *, sctp, sctp_hdr_t *,
+	    &mp->b_rptr[fp->sf_ixa->ixa_ip_hdr_length]);
+
 	(void) conn_ip_output(pkt, fp->sf_ixa);
 	BUMP_LOCAL(sctp->sctp_opkts);
 
